'ImportsXe[ggŖOԂ̎QƂȒPɂ܂B
Imports System.Drawing
Imports System.Windows.Forms
Imports Wakaba

Module Game

    Private Const STAR_MAX As Integer = 50        '̐
    Private Const STAR_SPEED As Integer = 4        '̈ړx
    Private Const STAR_ROLL_SPEED As Integer = 8   '̉]x

    Private Structure StarPos
        Dim X As Integer 'XW
        Dim Y As Integer 'YW
        Dim AddX As Integer  'Xړ
        Dim AddY As Integer 'Yړ
    End Structure

    Private Const MAPCHIP_SIZE As Integer = 32
    Private Const SCROLL_SPEED As Integer = 4 'XN[Xs[h

    Dim mintFps As Integer 'fpsvp
    Dim mintSkip As Integer 't[XLbvvp

    Private WithEvents t As Wakaba.GameTimer

    'IuWFNgϐ錾܂B
    Private w As Wakaba.Helper

    Sub Main()

        Try
            Dim objRnd As New Random
            Dim intRnd As Integer
            Dim intScroll As Integer = 0

            Dim intRoll As Integer = 0
            Dim Position(STAR_MAX) As StarPos

            Dim intBackFps As Integer
            Dim intBackSkip As Integer

            w = New Wakaba.Helper
            t = New Wakaba.GameTimer

            w.Initialize()

            'fps\pXvCg쐬
            w.SpriteCreate("fps", 128, 32)
            w.SpritePosition("fps", 0, 0, 0)
            w.SpriteShow("fps")

            w.SpriteCreate("}bv`bv", My.Resources.map, Helper.TransparentColor.None)

            w.SpriteCreate("wi1", 640, 480)
            w.SpriteShow("wi1")

            w.SpriteCreate("wi2", 640, 480)
            w.SpriteShow("wi2")

            '}bv`bv쐬
            For i As Integer = 0 To 14
                For j As Integer = 0 To 19
                    intRnd = objRnd.Next(0, 3)
                    w.SpriteCopy("wi1", CShort(j * MAPCHIP_SIZE), CShort(i * MAPCHIP_SIZE), "}bv`bv", intRnd * MAPCHIP_SIZE, 0, MAPCHIP_SIZE, MAPCHIP_SIZE)
                Next
            Next
            w.SpriteCopy("wi2", 0, 0, "wi1", 0, 0, 640, 480)

            '쐬
            w.SpriteCreate("", My.Resources.star, Helper.TransparentColor.PictureTopLeft)
            For i As Integer = 1 To STAR_MAX
                w.SpriteCreate("" & i.ToString, "", 0, 0, 64, 64)
                w.SpriteHitAdd("" & i.ToString, "萯", 0, 0, 64, 64)

                objRnd = New Random(i)
                Position(i).X = objRnd.Next(0, 640 - 64)
                Position(i).Y = objRnd.Next(0, 480 - 64)
                Position(i).AddX = STAR_SPEED
                Position(i).AddY = STAR_SPEED

                w.SpritePosition("" & i.ToString, i, Position(i).X, Position(i).Y)
                w.SpriteTransparent("" & i.ToString, 128)

                w.SpriteShow("" & i.ToString)
            Next

            'fpsv^C}[ݒ
            t = New Wakaba.GameTimer
            t.Interval = 1000
            t.TimerStart()

            Do
                'XN[ύX𔻒肷
                If w.KeyPush(Helper.KeyCodes.CodeZ) Then
                    w.ScreenChange(Helper.ScreenMode.Full)
                ElseIf w.KeyPush(Helper.KeyCodes.CodeX) Then
                    w.ScreenChange(Helper.ScreenMode.Window)
                End If

                'ړ
                For j As Integer = 1 To STAR_MAX

                    Dim info As Helper.SpriteInfo = w.SpriteInformation("" & j.ToString)

                    If info.X < 0 Then
                        Position(j).AddX = STAR_SPEED
                    End If

                    If 640 - 64 < info.X Then
                        Position(j).AddX = -STAR_SPEED
                    End If

                    If info.Y < 0 Then
                        Position(j).AddY = STAR_SPEED
                    End If

                    If 480 - 64 < info.Y Then
                        Position(j).AddY = -STAR_SPEED
                    End If

                    Position(j).X += Position(j).AddX
                    Position(j).Y += Position(j).AddY

                    w.SpriteRotation("" & j.ToString, intRoll)
                    w.SpritePosition("" & j.ToString, j, Position(j).X, Position(j).Y)
                Next

                If intRoll > 360 Then
                    intRoll = 0
                Else
                    intRoll += STAR_ROLL_SPEED
                End If

                'wiXN[
                w.SpritePosition("wi1", STAR_MAX + 1, intScroll, 0)
                w.SpritePosition("wi2", STAR_MAX + 1, intScroll - 640, 0)

                intScroll += SCROLL_SPEED
                If intScroll > 640 Then
                    intScroll = 0
                End If

                'fps\
                If mintFps = intBackFps And mintSkip = intBackSkip Then
                Else
                    Dim msg As String = "fps" & mintFps.ToString & " skip" & mintSkip.ToString

                    w.SpriteFillColor("fps", Color.FromArgb(0))
                    w.SpriteText("fps", msg, 0, 0, "lr SVbN", 16, FontStyle.Bold, Brushes.Black)

                    intBackFps = mintFps
                    intBackSkip = mintSkip
                End If

                w.ScreenRefresh(True)

            Loop While Not w.WindowClosing And Not w.KeyPush(Helper.KeyCodes.CodeEscape)

            w.ScreenChange(Helper.ScreenMode.Window)

        Catch ex As Exception
            MessageBox.Show(ex.Message & ex.StackTrace)
        End Try

        t.Dispose()
        w.Dispose()

    End Sub

    Private Sub t_Tick() Handles t.Tick

        'fps\
        If w IsNot Nothing Then

            mintFps = w.ScreenFpsCount
            mintSkip = w.ScreenFpsSkipCount

            w.ScreenFpsCount = 0
            w.ScreenFpsSkipCount = 0
        End If

    End Sub

End Module
